/* face.h
 * Nadim Abdo 1998
 *
 * Header file for face
 *
 * For Operating Systems 304-427B Assignment #3
 */

#ifndef _face_h_
#define _face_h_

#define CELL_ALIVE 1
#define CELL_DEAD  0
/*bitmasks for next generation info*/
#define CELL_ALIVE_NEXT 0x02 /*next generation*/
#define CELL_DEAD_NEXT  0x01

void RunLifeOnFace(int facenum);


typedef enum {DirHorizontal,DirVertical} walk_dir;

/*defines how to copy a N,E,S,W edge*/
typedef struct
{
  int startx; /*Origin of edge*/
  int starty;

  walk_dir dir; /*Edge's direction*/
}CopyOrigin;

/*Look Up table used when copying N,E,S,W edges*/
static CopyOrigin LUTCopyOrigin[] =
{
  {0,0,DirHorizontal
  },  /*North*/
  {N-1,0,DirVertical
  },  /*East*/
  {0,N-1,DirHorizontal
  },  /*South*/
  {0,0,DirVertical
  }   /*West*/
};



#endif
