/* life3dlviewer.h
 * Interface to 3d viewer library
 * Operating Systems - 304-427A, Fall 1998
 *
 * Nadim Abdo
 */


#ifndef _LIFE3DVIEWER_H_
#define _LIFE3DVIEWER_H_


/*viewer hard coded for 6 by 6 grids on each face*/
/*YOU CAN CHANGE this a recompile although 6 seems to be
  give good performance on the software on the OpenGL
  implementations in the UNIX lab. Try it on a fast SGI with
  16 by 16 for a really cool display!*/
#define CELLS_PER_EDGE 6

typedef enum{LVLFalse=0,LVLTrue=1
               } LVLBool;

/*Initialization*/
extern int LVLibInit(int argc,char **argv);
/*cleaup*/
extern int LVLibCleanup();

/*Current lib version*/
extern int LVLLibGetVersion();
/*Return number of cells allowed on each side*/
extern int LVLibGetNumCellsOnSide();

/*Set the face cells
  Input: faceN - faceID (0-5)
  cells is a 2D array - 1 for alive, 0 for dead*/
extern int LVLibSetFaceCells(int faceN,
                             int cells[][][CELLS_PER_EDGE]);

/*Initialise display*/
extern void LVLibStartDisplay();
/*Display new state*/
extern int LVLibUpdateDisplay();

/*Set the autorotation*/
/*if flag is True auto rotate enabled*/
/*On by default*/
extern void LVLibSetAutoRotate(LVLBool flag);

/*Set the angles for x,y,z rotation*/
extern void LVLibSetXangle(float x);
extern void LVLibSetYangle(float y);
extern void LVLibSetZangle(float z);
/*Get the angles for x,y,z rotation*/
extern float LVLibGetXangle();
extern float LVLibGetYangle();
extern float LVLibGetZangle();



#endif /*_LIFE3DVIEWER_H_*/
