/* semaph.c
 * Utitilty functions for using semaphores 
 * Nadim Abdo 1998
 */

#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/msg.h>

#include "semaph.h"
#include <assert.h>

void semwait(int semid)
{
  sem_op(semid,-1);
}

void semsignal(int semid)
{
  sem_op(semid,1);
}

/*Signal with the undo option*/
void semsignalundo(int semid)
{
  struct sembuf buf;
  buf.sem_num=0;
  buf.sem_op=1;
  buf.sem_flg=SEM_UNDO;
  if(-1==semop(semid,&buf,1))
    {
      
      perror("Semop failed\n");
      exit(1);
    }
}

void sem_op(int semid, int val)
{
  struct sembuf buf;
  buf.sem_num=0;
  buf.sem_op=val;
  buf.sem_flg=0;
  if(-1==semop(semid,&buf,1))
    {
      
      perror("Semop failed\n");
      exit(1);
    }
}



void sem_rm(int semid)
{
  if (semctl(semid, 0, IPC_RMID, 0) < 0)
    perror("can't IPC_RMID");
}

